<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Assignment #1</title>
</head>
<body>
<H1>Assignment #1</H1>





<B>Intermediate C Programming
<br>
<br>
UW Experimental College
</B><br>
<br>
<B>Assignment #1
</B><p><B>Handouts:
</B></p><p>Syllabus
<br><a href="PS1.html">Assignment #1</a>
<br><a href="http://www.eskimo.com/~scs/cclass/int/sx1.html">Class Notes, Chapter 15</a>
<br><a href="gamesource.html">Game source code</a>
<br><a href="gameintro.html">Notes about ``The Game''</a>
<p><B>Review Questions:
</B></p><OL><li>What are the four parts of a structure definition?
<li>What is <TT>p-&gt;m</TT> equivalent to?
<li>What's wrong with this code?
<pre>
	struct x *p = malloc(sizeof(struct x *));
</pre>
<li>The last code example in chapter 15 of the notes
reads lines from <TT>stdin</TT> and prints them back out in
reverse order.
What would happen if the <TT>prepend</TT> function did not
call <TT>malloc</TT> and <TT>strcpy</TT> to allocate space for 
a new copy of each listnode's item,
but instead simply set
<TT>newnode-&gt;item = newword</TT>?
</OL><p><B>Exercises:
</B></p><p>1.
Get the initial version of the game
(as handed out in class)
to compile and run.
It should print a ``?'' prompt,
and you should be able to type the ``n'', ``s'',
``e'', and ``w'' commands to attempt to move around,
and the ``take'' and ``drop'' commands
to pick up and drop objects.
(There are one or two other commands, which you can learn by 
studying the file <TT>commands.c</TT>.)
<p>Study and understand as much of the source code of the game as you can.
<p>2.
Add a ``help'' command
which prints a message listing the available verbs
(or at least the most common ones).
<p>3.
Add a ``long description'' field
to the <TT>object</TT> and <TT>room</TT> structures.
(It can either be an array of <TT>char</TT> or a pointer to <TT>char</TT>.)
Modify the initializations of the <TT>objects</TT> and 
<TT>rooms</TT> arrays in <TT>main.c</TT>
to initialize the description field
for some or all objects and rooms.
Arrange that the ``look'' command
print the long description of the current room
(if it has one),
and that the description is also printed
when the actor enters a new room.
Add an ``examine'' command
which prints the long description of an object,
if it has one.
(Otherwise, have it print
``You see nothing special about the <TT>%s</TT>.'')
<hr>
<hr>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-9
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
